#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';
	require "flush.pl";

        &ReadInput(*INPUT);
	&ParseData(*GLOBAL, $INPUT);
	$hostname = &IpswitchName();

        # Print out header
	print "HTTP/1.0 200 Script results follow\n";
#        &PrintButtonBar("NPHEADER", "Ping from: $hostname");
        &DispHelp;

        local ($ip_addr, $rep_val);
	$ip_addr = &GetValue($GLOBAL[0]);
	$rep_val = &GetValue($GLOBAL[1]);
			
	if( &IsIPAddr($ip_addr) ne 1 ) {
	     print "<center>Invalid IP address: \"$ip_addr\"</center>";
        }
	elsif( $rep_val eq 0 ) {
	     print "<center>Bad repeating count: \"$rep_val\"</center>";
        }
        else {

	     # Do ping
	     &ping($ip_addr, $rep_val);
        } 

        # Print out trailer
	print "<hr size=4>";
#        &PrintButtonBar("TRAILER");
	&PrintToe;
####### END MAIN ########

sub PrintToe {
    &SetUpHelp;
    &PrintHeadToe2("TRAILER",
                  "", 
                  "",
                  "",
                  "/cgi-bin/NPH-ping.pl?IH=$nhelp",
                  "");
}

sub DispHelp {
    &SetUpHelp;
    &PrintHeadToe2("NPHEADER",
		      "Ping from: $hostname",
		      "",
		      "",
		      "/cgi-bin/NPH-ping.pl?IH=$nhelp",
		      "");
}

sub ping {
    local ($ip_address, $rep_val) = @_;

    open (FD, "/sbin/ping -c $rep_val $ip_address 2>&1 | ");
    print "</center>\n";
    print "<pre>\n";
    while (<FD>) {
	print "$_\n";
	&flush(STDOUT);
    }
    print "</pre>\n";
    close(FD);
}

