#!/usr/bin/perl
#
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
# Copyright 1994 Steven E. Brenner
# Unpublished work.
# Permission granted to use and modify this library so long as the
# copyright above is maintained, modifications are documented, and
# credit is given for any use of the library.
# 
# The ReadInput() and ParseData() routines are derivatives
# of Steve Brenner's ReadParse routine in cgi-lib.pl.
######################################################################
#
# This library contains common subroutines 
# used in the IP Switch Monitor Tool.
#

# Globals

sub PrintHeader {
	&PrintButtonBar("HEADER", "IP Switch View");
}

sub IfLocation {
	local($ifname) = @_;
	local($retval) = 0;

   	if ($ifname =~ /atm-s\d*p\d*c\d*(s\d*p\d*c\d*)$/)
		{ return $switch{$1}; }
	else {
		if ($ifname =~ /atm-(s\d*p\d*c\d*)$/)
			{ return $1; }
	}
	return $retval;	
}

sub InitPortMap {
	local($maxatmlports) = 24;
	local($maxspinoliports) = 16;
	local($maxdecports) = 52;
	local($maxipswgwports) = 4;
    
	if ($IPSSWITCHTYPE eq "ATML") {
		for ($i=0; $i<$maxatmlports; $i++) {
			if ($i < 12)
				{ $switch{$i} = $i + 1; }
			else
				{ $switch{$i+4} = $i + 1; }
		}
	}
	if ($IPSSWITCHTYPE eq "SPINOLI") {
		for ($i=0; $i<$maxspinoliports; $i++)
			{ $switch{sprintf("s%dp1c0", $i)} = $i; }
	}
	if ($IPSSWITCHTYPE eq "DEC") {
		for ($i=0; $i<$maxdecports; $i++)
			{ $switch{$i} = $i; }
	}
}

sub SwitchPortName {
	local($index) = @_;
	local($s);

	if ($IPSSWITCHTYPE eq "DEC")
		{ $s = (($index-1)%4)+1; }
	if ($IPSSWITCHTYPE eq "ATML")
		{ $s = (($index-1)%4)+1; }
	if ($IPSSWITCHTYPE eq "SPINOLI")
		{ $s = (($index-1)%1)+1; }
	return $s;
}

sub SwitchAdjacency  {
local ($ifnum) = @_;

	if ($ifnum eq 1 )
		{ return "GSMP"; }
        if ($ips_data{"if$ifnum.flags"} =~ /RUNNING/)
		{ return "IFMP"; }
	return "<br>";
}

sub SwitchImageUp {
local ($ifnum) = @_;
	return "/images/green.gif";
}

1;
