#!/usr/bin/perl
#
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
# Copyright 1994 Steven E. Brenner
# Unpublished work.
# Permission granted to use and modify this library so long as the
# copyright above is maintained, modifications are documented, and
# credit is given for any use of the library.
# 
# The ReadInput() and ParseData() routines are derivatives
# of Steve Brenner's ReadParse routine in cgi-lib.pl.
######################################################################
#
# This library contains common subroutines 
# used in the IP Switch Gateway Monitor Tool.
#

# Globals

sub PrintHeader {   
        &PrintButtonBar("HEADER", "IP Switch Gateway View");  
}

sub IfLocation {
	local($ifname, $ifindex) = @_;
	local($retval) = 0;
	if (($ifname =~ /eth-s\d*p\d*c\d*/)||($ifname =~ /atm-s\d*p\d*c\d*/)||($ifname =~ /fddi-s\d*p\d*c\d*/))
		{ $retval = $switch{$ifname} = $ifindex; }
	return ($retval);	
}

sub InitPortMap {
	# Currently (i.e. aplha4), there is no "backplane" info
	# for IPSWGW interfaces. They can only be grouped according
	# to type and ordered according to BIOS discovery.
	# This is done at sysctl(net.route.all.iflist) parse time.
}

sub SwitchPortName {
	local($index) = @_;

	return (&LogicalName($index));
}

sub Adjacency  {
local ($ifnum) = @_;

	if ($ips_data{"if$ifnum.flags"} =~ /RUNNING/)
		{ return "IFMP"; }
	return "<br>";
}

sub SwitchImageUp  {
	local ($ifnum) = @_;

	if ($nic_data{"if$ips_far.flags"}) {
		if ($nic_data{"if$ips_far.flags"} =~ /UP/)
			{ return "/images/green.gif"; }
		else
			{ return "/images/red.gif"; }	
	}
	return "/images/black.gif";
}

1;
