#!/usr/bin/perl
#
$WEBDIR		= "/usr/local/www";
$CGIDIR		= "$WEBDIR/cgi-bin";
$STATSAF	= "/tmp/stats.access";

$CELLSZ		= 48;

$MAXINTERVAL	= 12;
$COUNTBITS	= 32;
$MAXCOUNT	= ((2**$COUNTBITS)-1);

$INTVLEN = 300;
$INTVDIELEN = 600;

$count = 0;

system("/bin/rm", "/usr/local/monitor/data/flow_stats.db");
open(SF, ">$STATSAF");   # Touch the stats file
print SF " ";
close(SF);
open(SF, "$STATSAF");   
$trash= <SF>;
close(SF);


#&openlog("poll.pl", "cons,pid", "daemon");

while (1) {
	&GetCounts;
	if (++$count > $MAXINTERVAL)
		{ $count = 1; }
	sleep($INTVLEN);
	($trash,$trash,$trash,$trash,$trash,$trash,$trash,$trash,
                      $atime,$mtime,$ctime,$trash,$trash)
                          = stat($STATSAF);
	if ($atime && (time()-$atime  > $INTVDIELEN)) {
	    last;
	}
}

#&syslog('notice', "Exiting due to unuse.\n");
&procstop();

sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

sub procstop {
  $machine=&get("machine");
  system ("/usr/local/config/bin/udw machine:$machine:process:poll.pl");
  system ("/usr/local/config/bin/dbset machine:$machine:process:poll.pl");
  return(1);
}

sub GetCounts {
	&ParseSysctl("ips.gsmp");
        &ParseSysctl("net.route.all.iflist");
	&ParseSysctl("ips.atm_if");

	dbmopen(%flow_stats, '/usr/local/monitor/data/flow_stats', 0666);

	$flow_stats{"interval.$count.total_cells"}		= 0;
	$flow_stats{"interval.$count.switched.total_cells"}	= 
	$flow_stats{"interval.$count.switched.cells"}		= 
	$flow_stats{"interval.$count.switched.bytes"}		= 0;
	$flow_stats{"interval.$count.switched.percent"}		= "";
	$flow_stats{"interval.$count.forwarded.total_cells"}	=
	$flow_stats{"interval.$count.forwarded.cells"}		=
	$flow_stats{"interval.$count.forwarded.bytes"}		= 0;
	$flow_stats{"interval.$count.forwarded.percent"}	= "";

	local($pc_sw);
	local($pc_fwd);
	local($curAtmIfIndex) = 1;

	while ($ips_data{"ips.atm_if\[$curAtmIfIndex\].ifindex"}) {
            local($curIfIndex)  = $ips_data{"ips.atm_if\[$curAtmIfIndex\].ifindex"};
	    local($gsmpCount) = 1;
	    local($gsmpifindex) = 0;
	    local($gsmppeeripsifindex) = 0;
	    while ($ips_data{"ips.gsmp\[$gsmpCount\].ifindex"}) {
	    	$gsmpifindex = $ips_data{"ips.gsmp\[$gsmpCount\].ifindex"};
	    	$gsmppeerifindex = 
			$ips_data{"ips.gsmp\[$gsmpCount\].peeripsifindex"};
		last if (($curIfIndex == $gsmpifindex) || 
			 ($curIfIndex == $gsmppeerifindex));
	    	++$gsmpCount;
	    }
	    if (($curIfIndex != $gsmpifindex) && ($curIfIndex != $gsmppeerifindex)) {
	
$flow_stats{"interval.$count.total_cells.ips.atm_if\[$curAtmIfIndex\].incells"}
	= int($ips_data{"ips.atm_if\[$curAtmIfIndex\].incells"});
$flow_stats{"interval.$count.total_cells"} +=
	int(&GetWrapAdjust("ips.atm_if\[$curAtmIfIndex\].incells"));
$flow_stats{"interval.$count.forwarded.total_cells.net.route.all.iflist\[$curIfIndex\].cells"} = 
int($ips_data{"net.route.all.iflist\[$curIfIndex\].ibytes"}/$CELLSZ);
$flow_stats{"interval.$count.forwarded.total_cells"} +=
int(&GetWrapAdjust("net.route.all.iflist\[$curIfIndex\].ibytes")/$CELLSZ);
	    }
	    ++$curAtmIfIndex;
	}

        if ($flow_stats{"interval.$count.total_cells"} >
            $flow_stats{"interval.$count.forwarded.total_cells"}) {
	   $flow_stats{"interval.$count.switched.total_cells"} =
		$flow_stats{"interval.$count.total_cells"} -
		$flow_stats{"interval.$count.forwarded.total_cells"};
        } else {
           $flow_stats{"interval.$count.switched.total_cells"} = 0;
	}

	if ($count) {
		local($prevCount) = $count - 1;
		local($intervalTotal) = 
			$flow_stats{"interval.$count.total_cells"} -
			$flow_stats{"interval.$prevCount.total_cells"};
                if ($intervalTotal < 0) {
			$intervalTotal *= -1;
		}
		local($pc_sw) = 0;
		local($pc_fwd) = 0;
		
		if ($flow_stats{"interval.$count.switched.total_cells"} >
		    $flow_stats{"interval.$prevCount.switched.total_cells"}) {
		$flow_stats{"interval.$count.switched.cells"} =
			$flow_stats{"interval.$count.switched.total_cells"} -
			$flow_stats{"interval.$prevCount.switched.total_cells"};		} else {
			$flow_stats{"interval.$count.switched.cells"} = 0;
		}
		if ($flow_stats{"interval.$count.forwarded.total_cells"} >
		    $flow_stats{"interval.$prevCount.forwarded.total_cells"}) {	
		$flow_stats{"interval.$count.forwarded.cells"} =
			$flow_stats{"interval.$count.forwarded.total_cells"} -
			$flow_stats{"interval.$prevCount.forwarded.total_cells"};		} else {
			$flow_stats{"interval.$count.forwarded.cells"} = 0;
		}
		if ($intervalTotal) {
			$pc_sw = 100 * ($flow_stats{"interval.$count.switched.cells"} / $intervalTotal);
                        if ($pc_sw < 0) {
				$pc_sw  = 0;
			}
                        if ($pc_sw > 100) {
				$pc_sw  = 100;
			}
                	$flow_stats{"interval.$count.switched.percent"} = sprintf("%5.2f", $pc_sw);
			$pc_fwd = 100 * ($flow_stats{"interval.$count.forwarded.cells"} / $intervalTotal);
                        if ($pc_fwd > 100 && $pc_sw == 0) {
				$pc_fwd = 100;
			}
                        if ($pc_sw == 100) {
				$pc_fwd = 0;
			}
                	$flow_stats{"interval.$count.forwarded.percent"} = sprintf("%5.2f", $pc_fwd);
		    }else{
			if ($flow_stats{"interval.$count.switched.cells"}<1) {
			    $pc_sw = 0;
			    $pc_fwd = 100;
			}
			if ($flow_stats{"interval.$count.forwarded.cells"}<1) {
			    $pc_sw = 100;
			    $pc_fwd = 0;
			}
			$flow_stats{"interval.$count.switched.percent"} = 
			    sprintf("%5.2f", $pc_sw); 
			$flow_stats{"interval.$count.forwarded.percent"} = 
			    sprintf("%5.2f", $pc_fwd); 
		    }
		if ($count eq $MAXINTERVAL) {
		$flow_stats{"interval.0.total_cells"} =
			int($flow_stats{"interval.$count.total_cells"});
		$flow_stats{"interval.0.switched.total_cells"} = 
			int($flow_stats{"interval.$count.switched.total_cells"});
		$flow_stats{"interval.0.forwarded.total_cells"} = 
			int($flow_stats{"interval.$count.forwarded.total_cells"});
		}
	}
	$flow_stats{"interval.$count.forwarded.bytes"} =
		int($CELLSZ * $flow_stats{"interval.$count.forwarded.cells"});
	$flow_stats{"interval.$count.switched.bytes"} =
		int($CELLSZ * $flow_stats{"interval.$count.switched.cells"});

	$flow_stats{"interval.countNum"} = $count;
	dbmclose(flow_stats);
}

sub GetWrapAdjust {
	local($inVar) = @_;
	
	if ($ips_data{$inVar} < $flow_data{"previous.$inVar"})
		{ ++$flow_data{"wrapCount.$inVar"}; }
	$flow_data{"previous.$inVar"} = $ips_data{$inVar};
	return ($MAXCOUNT * $flow_data{"wrapCount.$inVar"}) + $ips_data{$inVar};
}

sub ParseSysctl {
	local($CTLMIBOBJ)	= @_;
	local($IPSSYSCTL)	= "/usr/sbin/sysctl"; 
	local($_);

	if(!open(READSYSCTL, "$IPSSYSCTL $CTLMIBOBJ | "))
		{ &PrintMsgHdr("Can't open $IPSSYSCTL: $!"); return 1;	}
	while (<READSYSCTL>) {
		chop;
		if (/^$/ || !/(^\S*)\s*=\s*(.*)/)
			{ next;	}
		$ips_data{$1} = $2;
	}
	close(READSYSCTL); return;
}

