if (!defined &_SYS_VNODE_H_) {
    eval 'sub _SYS_VNODE_H_ {1;}';
    require 'sys/queue.ph';
    eval 'sub v_mountedhere {defined &v_un && &v_un.defined &vu_mountedhere && &vu_mountedhere;}';
    eval 'sub v_socket {defined &v_un && &v_un.defined &vu_socket && &vu_socket;}';
    eval 'sub v_specinfo {defined &v_un && &v_un.defined &vu_specinfo && &vu_specinfo;}';
    eval 'sub v_fifoinfo {defined &v_un && &v_un.defined &vu_fifoinfo && &vu_fifoinfo;}';
    eval 'sub VROOT {0x0001;}';
    eval 'sub VTEXT {0x0002;}';
    eval 'sub VSYSTEM {0x0004;}';
    eval 'sub VOLOCK {0x0008;}';
    eval 'sub VOWANT {0x0010;}';
    eval 'sub VXLOCK {0x0100;}';
    eval 'sub VXWANT {0x0200;}';
    eval 'sub VBWAIT {0x0400;}';
    eval 'sub VALIASED {0x0800;}';
    eval 'sub VDIROP {0x1000;}';
    eval 'sub VVMIO {0x2000;}';
    eval 'sub VNINACT {0x4000;}';
    eval 'sub VAGE {0x8000;}';
    eval 'sub VA_UTIMES_NULL {0x01;}';
    eval 'sub IO_UNIT {0x01;}';
    eval 'sub IO_APPEND {0x02;}';
    eval 'sub IO_SYNC {0x04;}';
    eval 'sub IO_NODELOCKED {0x08;}';
    eval 'sub IO_NDELAY {0x10;}';
    eval 'sub IO_VMIO {0x20;}';
    eval 'sub VSUID {04000;}';
    eval 'sub VSGID {02000;}';
    eval 'sub VSVTX {01000;}';
    eval 'sub VREAD {00400;}';
    eval 'sub VWRITE {00200;}';
    eval 'sub VEXEC {00100;}';
    eval 'sub VNOVAL {(-1);}';
    if (defined &KERNEL) {
	eval 'sub IFTOVT {
	    local($mode) = @_;
	    eval "(defined &iftovt_tab && &iftovt_tab[(($mode) & defined &S_IFMT && &S_IFMT) >> 12])";
	}';
	eval 'sub VTTOIF {
	    local($indx) = @_;
	    eval "(defined &vttoif_tab && &vttoif_tab[($indx)])";
	}';
	eval 'sub MAKEIMODE {
	    local($indx, $mode) = @_;
	    eval "( &VTTOIF($indx) | ($mode))";
	}';
	eval 'sub SKIPSYSTEM {0x0001;}';
	eval 'sub FORCECLOSE {0x0002;}';
	eval 'sub WRITECLOSE {0x0004;}';
	eval 'sub DOCLOSE {0x0008;}';
	eval 'sub V_SAVE {0x0001;}';
	eval 'sub V_SAVEMETA {0x0002;}';
	if (defined &DIAGNOSTIC) {
	    eval 'sub HOLDRELE {
	        local($vp) = @_;
	        eval " &holdrele($vp)";
	    }';
	    eval 'sub VATTR_NULL {
	        local($vap) = @_;
	        eval " &vattr_null($vap)";
	    }';
	    eval 'sub VHOLD {
	        local($vp) = @_;
	        eval " &vhold($vp)";
	    }';
	    eval 'sub VREF {
	        local($vp) = @_;
	        eval " &vref($vp)";
	    }';
	}
	else {
	    eval 'sub HOLDRELE {
	        local($vp) = @_;
	        eval "($vp)->defined &v_holdcnt && &v_holdcnt--";
	    }';
	    eval 'sub VATTR_NULL {
	        local($vap) = @_;
	        eval "(*($vap) = defined &va_null && &va_null)";
	    }';
	    eval 'sub VHOLD {
	        local($vp) = @_;
	        eval "($vp)->defined &v_holdcnt && &v_holdcnt++";
	    }';
	    eval 'sub VREF {
	        local($vp) = @_;
	        eval "($vp)->defined &v_usecount && &v_usecount++";
	    }';
	}
	eval 'sub NULLVP {(defined &NULL && &NULL);}';
	if (defined &VFS_LKM) {
	    eval 'sub VNODEOP_SET {
	        local($f) = @_;
	        eval " &DATA_SET(defined &MODVNOPS && &MODVNOPS,$f)";
	    }';
	}
	else {
	    eval 'sub VNODEOP_SET {
	        local($f) = @_;
	        eval " &DATA_SET(defined &vfs_opv_descs_ && &vfs_opv_descs_,$f)";
	    }';
	}
	eval 'sub LEASE_READ {0x1;}';
	eval 'sub LEASE_WRITE {0x2;}';
	if (defined &NFS) {
	    if (defined &NQNFS) {
		eval 'sub LEASE_CHECK {
		    local($vp, $p, $cred, $flag) = @_;
		    eval " &lease_check(($vp), ($p), ($cred), ($flag))";
		}';
		eval 'sub LEASE_UPDATETIME {
		    local($dt) = @_;
		    eval " &lease_updatetime($dt)";
		}';
	    }
	    else {
		eval 'sub LEASE_CHECK {
		    local($vp, $p, $cred, $flag) = @_;
		    eval "";
		}';
		eval 'sub LEASE_UPDATETIME {
		    local($dt) = @_;
		    eval "";
		}';
	    }
	}
	else {
	    eval 'sub LEASE_CHECK {
	        local($vp, $p, $cred, $flag) = @_;
	        eval "defined &do && &do {  &if(defined &lease_check && &lease_check)  &lease_check(($vp), ($p), ($cred), ($flag)); }  &while(0)";
	    }';
	    eval 'sub LEASE_UPDATETIME {
	        local($dt) = @_;
	        eval "defined &do && &do {  &if(defined &lease_updatetime && &lease_updatetime)  &lease_updatetime($dt); }  &while(0)";
	    }';
	}
    }
    eval 'sub VDESC_MAX_VPS {16;}';
    eval 'sub VDESC_VP0_WILLRELE {0x0001;}';
    eval 'sub VDESC_VP1_WILLRELE {0x0002;}';
    eval 'sub VDESC_VP2_WILLRELE {0x0004;}';
    eval 'sub VDESC_VP3_WILLRELE {0x0008;}';
    eval 'sub VDESC_NOMAP_VPP {0x0100;}';
    eval 'sub VDESC_VPP_WILLRELE {0x0200;}';
    eval 'sub VDESC_NO_OFFSET {-1;}';
    if (defined &KERNEL) {
	eval 'sub VOPARG_OFFSET {
	    local($p_type,$field) = @_;
	    eval "( (( (&((($p_type)defined &NULL && &NULL)->$field))) - ( defined &NULL && &NULL)))";
	}';
	eval 'sub VOPARG_OFFSETOF {
	    local($s_type,$field) = @_;
	    eval " &VOPARG_OFFSET($s_type*,$field)";
	}';
	eval 'sub VOPARG_OFFSETTO {
	    local($S_TYPE,$S_OFFSET,$STRUCT_P) = @_;
	    eval "(($S_TYPE)((($STRUCT_P))+($S_OFFSET)))";
	}';
	eval 'sub VOCALL {
	    local($OPSV,$OFF,$AP) = @_;
	    eval "(( *(($OPSV)[($OFF)])) ($AP))";
	}';
	eval 'sub VCALL {
	    local($VP,$OFF,$AP) = @_;
	    eval " &VOCALL(($VP)->defined &v_op && &v_op,($OFF),($AP))";
	}';
	eval 'sub VDESC {
	    local($OP) = @_;
	    eval "(&  &__CONCAT($OP,defined &_desc && &_desc))";
	}';
	eval 'sub VOFFSET {
	    local($OP) = @_;
	    eval "( &VDESC($OP)->defined &vdesc_offset && &vdesc_offset)";
	}';
	require 'vnode_if.ph';
    }
}
1;
